/*
 *
 * (C) COPYRIGHT 2014-2017 MStar Semiconductor, Inc. All rights reserved.
 *
 * This program is free software and is provided to you under the terms of the
 * GNU General Public License version 2 as published by the Free Software
 * Foundation, and any use by you of this program is subject to the terms
 * of such GNU licence.
 *
 * A copy of the licence is included with the program, and can also be obtained
 * from Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 *
 */

#include "mali_kbase_platform_mstar.h"

/* Registers */
DEFINE_REG_BANK(gpu,        0x110800);
DEFINE_REG_BANK(gpu_pll,    0x160f00);
DEFINE_REG_BANK(clkgen1,    0x103300);
DEFINE_REG_BANK(miu0,       0x101200);
DEFINE_REG_BANK(miu1,       0x100600);

DEFINE_REG(gpu, soft_reset,     0x0, 0, 0);
DEFINE_REG(gpu, always_on,      0x0, 8, 8);
DEFINE_REG(gpu, sram_sd_en,     0x43, 3, 3);
DEFINE_REG(gpu, riu,            0x6a, 0, 0);
DEFINE_REG(gpu, mfdec,          0x6a, 1, 1);
DEFINE_REG(gpu, miu0_start,     0x75, 0, 15);
DEFINE_REG(gpu, miu0_end,       0x76, 0, 15);
DEFINE_REG(gpu, miu1_start,     0x77, 0, 15);
DEFINE_REG(gpu, miu1_end,       0x78, 0, 15);
DEFINE_REG(gpu, disable_half_cores, 0x17, 8, 8);

DEFINE_REG(gpu_pll, g3d_pll,    0x11, 8, 15);
DEFINE_REG(gpu_pll, set_armpll_post_divn, 0x13, 8, 15);
DEFINE_REG(gpu_pll, set_armpll_post,    0x15, 0, 7);
DEFINE_REG(gpu_pll, set_lo,     0x60, 0, 15);
DEFINE_REG(gpu_pll, set_hi,     0x61, 0, 7);
DEFINE_REG(gpu_pll, sld,        0x62, 0, 0);

DEFINE_REG(clkgen1, ckg_gpu,    0x20, 0, 4);

DEFINE_REG(miu0, dram_size,     0x69, 12, 15);
DEFINE_REG(miu1, dram_size,     0x69, 12, 15);

/* Marcos to convert Mali frequency to register value */
#define MHZ_TO_REG(MHZ) (0xA2000000/(MHZ))
