/*------------------------------------------------------------------------------
 * MediaTek Inc. (C) 2019. All rights reserved.
 *
 * Copyright Statement:
 *
 * This software/firmware and related documentation ("MediaTek Software") are
 * protected under relevant copyright laws. The information contained herein is
 * confidential and proprietary to MediaTek Inc. and/or its licensors. Without
 * the prior written permission of MediaTek inc. and/or its licensors, any
 * reproduction, modification, use or disclosure of MediaTek Software, and
 * information contained herein, in whole or in part, shall be strictly
 * prohibited.
 *
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
 * RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO RECEIVER
 * ON AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NONINFRINGEMENT. NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH
 * RESPECT TO THE SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY,
 * INCORPORATED IN, OR SUPPLIED WITH THE MEDIATEK SOFTWARE, AND RECEIVER AGREES
 * TO LOOK ONLY TO SUCH THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO.
 * RECEIVER EXPRESSLY ACKNOWLEDGES THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO
 * OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES CONTAINED IN MEDIATEK
 * SOFTWARE. MEDIATEK SHALL ALSO NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE
 * RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S
 * ENTIRE AND CUMULATIVE LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE
 * RELEASED HEREUNDER WILL BE, AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE
 * MEDIATEK SOFTWARE AT ISSUE, OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE
 * CHARGE PAID BY RECEIVER TO MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
 *
 * The following software/firmware and/or related documentation ("MediaTek
 * Software") have been modified by MediaTek Inc. All revisions are subject to
 * any receiver's applicable license agreements with MediaTek Inc.
 *----------------------------------------------------------------------------*/

#include "mali_kbase_platform_mstar.h"

#define FPGA_TEST_DETILE 0

DEFINE_REG_BANK(gpu,        0x110800);
DEFINE_REG_BANK(gpu_pll,    0x160f00);
DEFINE_REG_BANK(clkgen1,    0x103300);

DEFINE_REG_BANK(miu0,       0x101200);
DEFINE_REG_BANK(miu1,       0x100600);

//bank for WROR and RROR
DEFINE_REG_BANK(rror,       0x162100);
DEFINE_REG_BANK(wror,       0x161000);

//reg for RROR
DEFINE_REG(rror, ror_bypass,           0x00, 0, 0);
DEFINE_REG(rror, ror_status_clear,     0x00, 8, 8);
DEFINE_REG(rror, ror_inorder,          0x01, 0, 0);
DEFINE_REG(rror, miu_hw_arb_update,    0x1f, 8, 8);

//req for WROR
DEFINE_REG(wror, ror_bypass,           0x00, 0, 0);
DEFINE_REG(wror, ror_status_clear,     0x00, 8, 8);
DEFINE_REG(wror, ror_inorder,          0x01, 0, 0);
DEFINE_REG(wror, miu_hw_arb_update,    0x1f, 8, 8);

//reg for g3d_status_clr
DEFINE_REG(gpu,  g3d_status_clear,     0x61, 3, 3);

DEFINE_REG(gpu, soft_reset,            0x0,  0, 0);
DEFINE_REG(gpu, secure_sw_reset,       0x0, 1, 1);
DEFINE_REG(gpu, sram_sd_en,            0x43, 3, 3);
DEFINE_REG(gpu, dynamic_clk_gating_en, 0x4b, 8, 8);
DEFINE_REG(gpu, gpu_dram_mask_en,      0x5b, 0, 0);
DEFINE_REG(gpu, rreq_rd_len0,          0x60, 8, 10);
DEFINE_REG(gpu, rreq_rd_len1,          0x61, 5, 7);

DEFINE_REG(gpu, riu,            0x6a,  0, 0);
DEFINE_REG(gpu, miu0_start,     0x75,  0, 15);
DEFINE_REG(gpu, miu0_end,       0x76,  0, 15);
DEFINE_REG(gpu, miu1_start,     0x77,  0, 15);
DEFINE_REG(gpu, miu1_end,       0x78,  0, 15);
DEFINE_REG(gpu, nodefine_hit_r, 0x7b,  4, 4);

DEFINE_REG(gpu_pll, ctrl0,      0x3,   0, 0);
DEFINE_REG(gpu_pll, ctrl1,      0x4,   0, 7);

DEFINE_REG(clkgen1, ckg_gpu,    0x20,  0, 0);

DEFINE_REG(miu0, dram_size,     0x69, 12, 15);
DEFINE_REG(miu1, dram_size,     0x69, 12, 15);

#if FPGA_TEST_DETILE
DEFINE_REG_BANK(disp_mfdec0, 0x122d00);

DEFINE_REG(gpu, mfdec_y_start_low,       0x18, 0, 15);
DEFINE_REG(gpu, mfdec_y_start_high,      0x19, 0, 5);
DEFINE_REG(gpu, mfdec_y_end_low,         0x1a, 0, 15);
DEFINE_REG(gpu, mfdec_y_end_high,        0x1b, 0, 5);
DEFINE_REG(gpu, mfdec_uv_start_low,      0x1c, 0, 15);
DEFINE_REG(gpu, mfdec_uv_start_high,     0x1d, 0, 5);
DEFINE_REG(gpu, mfdec_uv_end_low,        0x1e, 0, 15);
DEFINE_REG(gpu, mfdec_uv_end_high,       0x1f, 0, 5);
DEFINE_REG(gpu, mfdec_adr_idx,           0x3a, 0, 3);
DEFINE_REG(gpu, mfdec_adr_update,        0x3a, 4, 4);
DEFINE_REG(gpu, mfdec_valid,             0x52, 0, 15);
DEFINE_REG(gpu, video_pitch,             0x53, 0, 14);
DEFINE_REG(gpu, mfdec_16b_mode,          0x54, 0, 15);
DEFINE_REG(gpu, mfdec_off,               0x6a, 1, 1);

DEFINE_REG(disp_mfdec0, mfdec_detile_rst,          0x29, 0, 0);

DEFINE_REG(disp_mfdec0, prg_fb_type,               0x8,  0, 1);
DEFINE_REG(disp_mfdec0, prg_fb_idx,                0x8,  4, 7);
DEFINE_REG(disp_mfdec0, fb_para_data_low,          0x9,  0, 15);
DEFINE_REG(disp_mfdec0, fb_para_data_high,         0xa,  0, 15);

DEFINE_REG(disp_mfdec0, gpu_counter_rst,           0x20, 0, 0);
DEFINE_REG(disp_mfdec0, gpu_count_all_en,          0x20, 2, 2);
DEFINE_REG(disp_mfdec0, gpu_count_sel,             0x20, 4, 7);
DEFINE_REG(disp_mfdec0, gpu_counter_fbidx,         0x21, 0, 3);
DEFINE_REG(disp_mfdec0, gpu_counter_fbidx_en,      0x21, 8, 8);
DEFINE_REG(disp_mfdec0, gpu_req_cnt_low,           0x22, 0, 15);
DEFINE_REG(disp_mfdec0, gpu_req_cnt_high,          0x23, 0, 15);
DEFINE_REG(disp_mfdec0, time_counter_rst,          0x24, 0, 0);
DEFINE_REG(disp_mfdec0, time_counter_en,           0x24, 1, 1);
DEFINE_REG(disp_mfdec0, time_cnt_low,              0x25, 0, 15);
DEFINE_REG(disp_mfdec0, time_cnt_high,             0x26, 0, 15);

DEFINE_REG(disp_mfdec0, mif_bwm_enable,            0x28, 0, 0);
DEFINE_REG(disp_mfdec0, mif_bwm_rreq_sample,       0x28, 2, 3);
DEFINE_REG(disp_mfdec0, mif_bwm_latency_avg,       0x28, 4, 6);
DEFINE_REG(disp_mfdec0, mif_bwm_debug_sel,         0x28, 8, 11);

// VDE Control
DEFINE_REG(disp_mfdec0, ce_de_bypass_en,           0x30, 0, 0);
DEFINE_REG(disp_mfdec0, 8bit_mode_en,              0x30, 1, 1);
DEFINE_REG(disp_mfdec0, en_sw_lcnt,                0x30, 2, 2);
DEFINE_REG(disp_mfdec0, sw_lcnt,                   0x30, 3, 3);
DEFINE_REG(disp_mfdec0, 8bit_tr_lsc,               0x30, 4, 4);
DEFINE_REG(disp_mfdec0, vs_rst,                    0x30, 5, 5);

// mif/miu Control
DEFINE_REG(disp_mfdec0, mif_burst_ctrl_low,        0x51, 0, 15);
DEFINE_REG(disp_mfdec0, mif_burst_ctrl_high,       0x52, 0, 15);

// debug bus
DEFINE_REG(disp_mfdec0, mfdec_dbus_low,            0x66, 0, 15);
DEFINE_REG(disp_mfdec0, mfdec_dbus_high,           0x67, 0, 7);
DEFINE_REG(disp_mfdec0, mfdec_dbus_sel,            0x67, 8, 15);
#endif
