/*------------------------------------------------------------------------------
 * MediaTek Inc. (C) 2020. All rights reserved.
 *
 * Copyright Statement:
 *
 * This software/firmware and related documentation ("MediaTek Software") are
 * protected under relevant copyright laws. The information contained herein is
 * confidential and proprietary to MediaTek Inc. and/or its licensors. Without
 * the prior written permission of MediaTek inc. and/or its licensors, any
 * reproduction, modification, use or disclosure of MediaTek Software, and
 * information contained herein, in whole or in part, shall be strictly
 * prohibited.
 *
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
 * RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO RECEIVER
 * ON AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NONINFRINGEMENT. NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH
 * RESPECT TO THE SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY,
 * INCORPORATED IN, OR SUPPLIED WITH THE MEDIATEK SOFTWARE, AND RECEIVER AGREES
 * TO LOOK ONLY TO SUCH THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO.
 * RECEIVER EXPRESSLY ACKNOWLEDGES THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO
 * OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES CONTAINED IN MEDIATEK
 * SOFTWARE. MEDIATEK SHALL ALSO NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE
 * RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S
 * ENTIRE AND CUMULATIVE LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE
 * RELEASED HEREUNDER WILL BE, AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE
 * MEDIATEK SOFTWARE AT ISSUE, OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE
 * CHARGE PAID BY RECEIVER TO MEDIATEK FOR SUCH MEDIATEKBSOFTWARE AT ISSUE.
 *
 * The following software/firmware and/or related documentation ("MediaTek
 * Software") have been modified by MediaTek Inc. All revisions are subject to
 * any receiver's applicable license agreements with MediaTek Inc.
 *----------------------------------------------------------------------------*/

#include "mali_kbase_platform_mstar.h"

/* Registers */
DEFINE_REG_BANK(gpu,        0x110800);
DEFINE_REG_BANK(gpu_pll,    0x160f00);
DEFINE_REG_BANK(clkgen1,    0x103300);
DEFINE_REG_BANK(mpu,         0x313800);

DEFINE_REG_BANK(miu0,       0x101200);
DEFINE_REG_BANK(miu1,       0x100600);

//bank for WROR and RROR
DEFINE_REG_BANK(rror,       0x161200);
DEFINE_REG_BANK(wror,       0x161000);

DEFINE_REG(mpu, check_stopped, 0x74, 8, 8);
DEFINE_REG(mpu, init_done, 0x74, 9, 9);

//reg for RROR
DEFINE_REG(rror, ror_status_clear,     0x00, 8, 8);
DEFINE_REG(rror, ror_bypass,          0x00, 0, 0);
DEFINE_REG(rror, ror_inorder,          0x01, 0, 0);
DEFINE_REG(rror, miu_hw_arb_update,    0x1f, 8, 8);

//req for WROR
DEFINE_REG(wror, ror_status_clear,     0x00, 8, 8);
DEFINE_REG(wror, ror_bypass,          0x00, 0, 0);
DEFINE_REG(wror, ror_inorder,          0x01, 0, 0);
DEFINE_REG(wror, ror_inorder_autoblock,          0x01d, 0, 0);
DEFINE_REG(wror, miu_hw_arb_update,    0x1f, 8, 8);

//reg for g3d_status_clr
DEFINE_REG(gpu,  g3d_status_clear,     0x61, 3, 3);

DEFINE_REG(gpu, soft_reset,     0x0, 0, 0);
DEFINE_REG(gpu, secure_sw_reset,     0x0, 1, 1);
DEFINE_REG(gpu, sram_sd_en,     0x43, 3, 3);
DEFINE_REG(gpu, dynamic_clk_gating_en,     0x4b, 8, 8);
DEFINE_REG(gpu, gpu_dram_mask_en,     0x5b, 0, 0);
DEFINE_REG(gpu, slow_b,     0x5b, 1, 1);

DEFINE_REG(gpu, gpu_nodefine_addr_l,     0x5c, 0, 15);
DEFINE_REG(gpu, gpu_nodefine_addr_h,     0x5d, 0, 15);
DEFINE_REG(gpu, gpu_nodefine_addr_sel, 0x5e, 2, 3);
DEFINE_REG(gpu, gpu_bridge_idle, 0x5e, 4, 4);
DEFINE_REG(gpu, rreq_rd_len0,    0x60, 8, 10);
DEFINE_REG(gpu, rreq_rd_len1,    0x61, 5, 7);

DEFINE_REG(gpu, riu,            0x6a, 0, 0);
DEFINE_REG(gpu, g3d_bri_status_0l, 0x6b, 0, 15);
DEFINE_REG(gpu, g3d_bri_status_0h, 0x6c, 0, 15);
DEFINE_REG(gpu, g3d_bri_status_1l, 0x6d, 0, 15);
DEFINE_REG(gpu, g3d_bri_status_1h, 0x6e, 0, 15);
DEFINE_REG(gpu, miu0_start,     0x75, 0, 15);
DEFINE_REG(gpu, miu0_end,       0x76, 0, 15);
DEFINE_REG(gpu, miu1_start,     0x77, 0, 15);
DEFINE_REG(gpu, miu1_end,       0x78, 0, 15);
DEFINE_REG(gpu, nodefine_hit_w, 0x7b, 3, 3);
DEFINE_REG(gpu, nodefine_hit_r, 0x7b, 4, 4);
DEFINE_REG(mpu, mpu_enable, 0x60, 0, 0);

DEFINE_REG(gpu_pll, ctrl0,    0x3, 0, 0);
DEFINE_REG(gpu_pll, ctrl1,    0x4, 0, 7);


DEFINE_REG(clkgen1, ckg_gpu,    0x20, 0, 0);

DEFINE_REG(miu0, dram_size,     0x69, 12, 15);
DEFINE_REG(miu1, dram_size,     0x69, 12, 15);

#define GPU_CLOCK_STEP              12

//bank for mpu
DEFINE_REG_BANK(mpu_global,       0x312000);
DEFINE_REG_BANK(mpu_bypass,       0x313700);
DEFINE_REG_BANK(mpu_local,       0x313800);

//reg for mpu
DEFINE_REG(mpu_global, mpu_table_base_low, 0x2, 0, 15);
DEFINE_REG(mpu_global, mpu_table_base_high, 0x3, 0, 3);
DEFINE_REG(mpu_global, mpu_area0_start, 0x4, 0, 12);
DEFINE_REG(mpu_global, mpu_area0_end, 0x5, 0, 12);
DEFINE_REG(mpu_global, mpu_area1_start, 0x6, 0, 12);
DEFINE_REG(mpu_global, mpu_area1_end, 0x7, 0, 12);
DEFINE_REG(mpu_global, mpu_table_update, 0x8, 0, 0);
DEFINE_REG(mpu_global, mpu_enable, 0x9, 0, 0);

DEFINE_REG(mpu_global, mpu_table_max_1, 0x14, 0, 15);
DEFINE_REG(mpu_global, mpu_table_max_2, 0x15, 0, 15);



DEFINE_REG(mpu_local, mpu_table_base_low, 0x2, 0, 15);
DEFINE_REG(mpu_local, mpu_table_base_high, 0x3, 0, 3);
DEFINE_REG(mpu_local, mpu_area0_start, 0x4, 0, 12);
DEFINE_REG(mpu_local, mpu_area0_end, 0x5, 0, 12);
DEFINE_REG(mpu_local, mpu_area1_start, 0x6, 0, 12);
DEFINE_REG(mpu_local, mpu_area1_end, 0x7, 0, 12);
DEFINE_REG(mpu_local, mpu_table_update, 0x8, 0, 0);




DEFINE_REG(mpu_global, mpu_table_invalid_mode, 0xd, 0, 0);
DEFINE_REG(mpu_global, mpu_iommu_table_invalid_fire, 0x10, 0, 0);

DEFINE_REG(mpu_local, mpu_iommu_local, 0x61, 0, 15);
DEFINE_REG(mpu_local, mpu_bypass_debug, 0x20, 2, 2);

DEFINE_REG(mpu_bypass, mpu_bypass_table_content, 0x00, 0, 3);
DEFINE_REG(mpu_local, mpu_bypass_table_size, 0x20, 4, 5);
DEFINE_REG(mpu_local, mpu_bypass_enable, 0x20, 1, 1);
DEFINE_REG(mpu_local, mpu_enable, 0x60, 0, 0);




#if MTK_DTV_GDEC
DEFINE_REG_BANK(disp_mfdec0, 0x122d00);
DEFINE_REG_BANK(mfdec_clock, 0x100b00);
DEFINE_REG(mfdec_clock, ckg_gpu_mfdec, 0x2c, 8, 8);

//b00: mfdec ip clcok is 666 Mhz
//b01: mfdec ip clcok is 576 Mhz
//b10: mfdec ip clcok is 480 Mhz
//b11: mfdec ip clcok is 432 Mhz
DEFINE_REG(mfdec_clock, ckg_gpu_mfdec_freq, 0x2c, 10, 11);


DEFINE_REG(mfdec_clock, CKG_DC_SRAM0_MFDEC_USE, 0x4f, 0, 3);
DEFINE_REG(mfdec_clock, CKG_DC_SRAM1_MFDEC_USE, 0x4f, 4, 7);

DEFINE_REG(gpu, mfdec_y_start_low,       0x18, 0, 15);
DEFINE_REG(gpu, mfdec_y_start_high,      0x19, 0, 5);
DEFINE_REG(gpu, mfdec_y_end_low,         0x1a, 0, 15);
DEFINE_REG(gpu, mfdec_y_end_high,        0x1b, 0, 5);
DEFINE_REG(gpu, mfdec_uv_start_low,      0x1c, 0, 15);
DEFINE_REG(gpu, mfdec_uv_start_high,     0x1d, 0, 5);
DEFINE_REG(gpu, mfdec_uv_end_low,        0x1e, 0, 15);
DEFINE_REG(gpu, mfdec_uv_end_high,       0x1f, 0, 5);
DEFINE_REG(gpu, mfdec_adr_idx,           0x3a, 0, 3);
DEFINE_REG(gpu, mfdec_adr_update,        0x3a, 4, 4);
DEFINE_REG(gpu, mfdec_valid,             0x52, 0, 15);
DEFINE_REG(gpu, video_pitch,             0x53, 0, 14);
DEFINE_REG(gpu, mfdec_16b_mode,          0x54, 0, 15);
DEFINE_REG(gpu, mfdec_divider_en,        0x57, 8, 8);
DEFINE_REG(gpu, mfdec_linear_mode,       0x57, 9, 9);
DEFINE_REG(gpu, mfdec_off,               0x6a, 1, 1);

DEFINE_REG(disp_mfdec0, mfdec_clk_gated,               0x0,  12, 12);
DEFINE_REG(disp_mfdec0, mfdec_reset,                   0x0,  0,  0);
DEFINE_REG(disp_mfdec0, mfdec_frame_start_xpu,         0x0,  8,  8);
DEFINE_REG(disp_mfdec0, mfdec_frame_end_xpu,           0x0,  9,  9);
DEFINE_REG(disp_mfdec0, mfdec_xpu_sel,                 0x1,  0,  0);
DEFINE_REG(disp_mfdec0, gpu_mfdec_map,                 0x1,  4,  4);
DEFINE_REG(disp_mfdec0, cpu_mfdec_map,                 0x1,  5,  5);
DEFINE_REG(disp_mfdec0, prg_fb_type,                   0x8,  0,  1);
DEFINE_REG(disp_mfdec0, prg_fb_idx,                    0x8,  4,  7);
DEFINE_REG(disp_mfdec0, fb_para_data_low,              0x9,  0,  15);
DEFINE_REG(disp_mfdec0, fb_para_data_high,             0xa,  0,  15);
DEFINE_REG(disp_mfdec0, tagram_inv,                    0xe,  0,  0);
DEFINE_REG(disp_mfdec0, rt_tagram_inv,                 0xe,  1,  1);
DEFINE_REG(disp_mfdec0, vd_iommu_tagram_inv,           0xe,  4,  4);
DEFINE_REG(disp_mfdec0, mfd_l_cache_flush_timeout_lb,  0x12, 0,  5);
DEFINE_REG(disp_mfdec0, mfd_l_cache_flush_timeout_ub,  0x12, 8,  13);
DEFINE_REG(disp_mfdec0, mfd_ofs_cache,                 0x16, 15, 15);
DEFINE_REG(disp_mfdec0, mfd_cpx_pf_en,                 0x50, 12, 12);
#endif


DEFINE_REG_BANK(miu0_clock,       0x152b00);
DEFINE_REG_BANK(miu1_clock,       0x152c00);

DEFINE_REG(miu0_clock, dynamic_clock,                 0x64, 0, 15);
DEFINE_REG(miu1_clock, dynamic_clock,                 0x64, 0, 15);

